<template>
  <el-dialog :append-to-body="true" :close-on-click-modal="false" :before-close="cancel" :visible.sync="dialog" :title="isAdd ? '新增' : '编辑'" width="50%">
    <el-form ref="form" :model="form" :rules="rules" size="small" label-width="80px">
      <el-form-item label="ID" prop="id" >
        <el-input v-model.trim="form.id" :disabled="isAdd ? false : true" style="width: 370px;"/>
      </el-form-item>
      <el-form-item label="类型名称" prop="typename" >
        <el-input v-model.trim="form.typename" style="width: 370px;"/>
      </el-form-item>
      <el-form-item label="设备类型" >
        <template >
          <el-checkbox-group v-model="ItemArray">
            <el-checkbox v-for="val in itemValue" :key="val.code" :label="val.subject">{{ val.subject }}</el-checkbox>
          </el-checkbox-group>
        </template>
      </el-form-item>
    </el-form>
    <div slot="footer" class="dialog-footer">
      <el-button type="text" @click="cancel">取消</el-button>
      <el-button :loading="loading" type="primary" @click="doSubmit">确认</el-button>
    </div>
  </el-dialog>
</template>

<script>
import { add, edit } from '@/api/sDevicetype'
import { selectAll } from '@/api/sItem'
export default {
  props: {
    isAdd: {
      type: Boolean,
      required: true
    }
  },
  data() {
    return {
      loading: false, dialog: false, ItemArray: [], ItemCode: [], ItemGs: [],
      form: {
        id: '',
        typename: '',
        code: '',
        subject: '',
        gs: '',
        createTime: '',
        updateTime: ''
      },
      rules: {
        id: [
          { required: true, message: '请输入ID', trigger: 'blur' }
        ],
        typename: [
          { required: true, message: '请输入设备类型名称', trigger: 'blur' }
        ]
      },
      itemValue: []
    }
  },
  mounted() {
    this.selectAllForm()
  },
  methods: {
    cancel() {
      this.resetForm()
    },
    doSubmit() {
      this.$refs['form'].validate((valid) => {
        if (valid) {
          this.loading = true
          // console.log(this.ItemArray)
          this.form.subject = this.ItemArray.toString()
          for (var i = 0; i < this.itemValue.length; i++) {
            var sub1 = this.itemValue[i].subject
            for (var j = 0; j < this.ItemArray.length; j++) {
              var sub2 = this.ItemArray[j]
              if (sub1 === sub2) {
                this.ItemCode[j] = this.itemValue[i].code
                this.ItemGs[j] = this.itemValue[i].gs
              }
            }
          }
          this.form.code = this.ItemCode.toString()
          this.form.gs = this.ItemGs.toString()
          console.log(this.form)
          if (this.isAdd) {
            this.doAdd()
          } else {
            this.doEdit()
          }
        }
      })
    },
    doAdd() {
      add(this.form).then(res => {
        this.resetForm()
        this.$notify({
          title: '添加成功',
          type: 'success',
          duration: 2500
        })
        this.loading = false
        this.$parent.init()
      }).catch(err => {
        this.loading = false
        console.log(err.response.data.message)
      })
    },
    doEdit() {
      edit(this.form).then(res => {
        this.resetForm()
        this.$notify({
          title: '修改成功',
          type: 'success',
          duration: 2500
        })
        this.loading = false
        this.$parent.init()
      }).catch(err => {
        this.loading = false
        console.log(err.response.data.message)
      })
    },
    resetForm() {
      this.dialog = false
      this.$refs['form'].resetFields()
      this.form = {
        id: '',
        typename: '',
        code: '',
        subject: '',
        gs: '',
        createTime: '',
        updateTime: ''
      }
      this.ItemArray = []
      this.ItemCode = []
      this.ItemGs = []
    },
    selectAllForm() {
      selectAll().then(response => {
        this.itemValue = response
      })
    }
  }
}
</script>

<style scoped>

</style>
